From d6c85a0a72bdf795006af4855f633e376f7fc9f2 Mon Sep 17 00:00:00 2001
From: Cecil Hugh Watson <knoppmyth@gmail.com>
Date: Thu, 15 Jan 2009 23:11:46 -0800
Subject: Various packages need for LCDproc.

---
 abs/extra-testing/autoconf/PKGBUILD                |  25 ++++
 abs/extra-testing/autoconf/autoconf.install        |  20 +++
 abs/extra-testing/bmp/0.9.7-visualization.patch    |  12 ++
 abs/extra-testing/bmp/0.9.7.1-visualization.patch  |  12 ++
 abs/extra-testing/bmp/PKGBUILD                     |  25 ++++
 .../bmp/bmp-0.9.7.1-crossfade-0.3.9.patch          | 108 +++++++++++++++++
 abs/extra-testing/gd/PKGBUILD                      |  23 ++++
 abs/extra-testing/gdk-pixbuf/PKGBUILD              |  33 +++++
 .../gdk-pixbuf-0.22.0-bmp_reject_corrupt.patch     |  48 ++++++++
 .../gdk-pixbuf/gdk-pixbuf-0.22.0-bmp_secure.patch  |  19 +++
 .../gdk-pixbuf/gdk-pixbuf-0.22.0-loaders.patch     | 134 +++++++++++++++++++++
 .../gdk-pixbuf/gdk-pixbuf-0.22.0-m4.patch          |   9 ++
 abs/extra-testing/id3lib/PKGBUILD                  |  29 +++++
 .../id3lib/id3lib-3.8.3-CVE-2007-4460.patch        |  49 ++++++++
 .../id3lib/id3lib-3.8.3-gcc-4.3.patch              |  83 +++++++++++++
 .../patch_id3lib_3.8.3_UTF16_writing_bug.diff      |  39 ++++++
 abs/extra-testing/libftdi/PKGBUILD                 |  19 +++
 abs/extra-testing/libmrss/PKGBUILD                 |  20 +++
 abs/extra-testing/libnxml/PKGBUILD                 |  22 ++++
 abs/extra-testing/serdisplib/PKGBUILD              |  22 ++++
 abs/extra-testing/xosd/PKGBUILD                    |  26 ++++
 21 files changed, 777 insertions(+)
 create mode 100644 abs/extra-testing/autoconf/PKGBUILD
 create mode 100644 abs/extra-testing/autoconf/autoconf.install
 create mode 100644 abs/extra-testing/bmp/0.9.7-visualization.patch
 create mode 100644 abs/extra-testing/bmp/0.9.7.1-visualization.patch
 create mode 100644 abs/extra-testing/bmp/PKGBUILD
 create mode 100644 abs/extra-testing/bmp/bmp-0.9.7.1-crossfade-0.3.9.patch
 create mode 100644 abs/extra-testing/gd/PKGBUILD
 create mode 100644 abs/extra-testing/gdk-pixbuf/PKGBUILD
 create mode 100644 abs/extra-testing/gdk-pixbuf/gdk-pixbuf-0.22.0-bmp_reject_corrupt.patch
 create mode 100644 abs/extra-testing/gdk-pixbuf/gdk-pixbuf-0.22.0-bmp_secure.patch
 create mode 100644 abs/extra-testing/gdk-pixbuf/gdk-pixbuf-0.22.0-loaders.patch
 create mode 100644 abs/extra-testing/gdk-pixbuf/gdk-pixbuf-0.22.0-m4.patch
 create mode 100644 abs/extra-testing/id3lib/PKGBUILD
 create mode 100644 abs/extra-testing/id3lib/id3lib-3.8.3-CVE-2007-4460.patch
 create mode 100644 abs/extra-testing/id3lib/id3lib-3.8.3-gcc-4.3.patch
 create mode 100644 abs/extra-testing/id3lib/patch_id3lib_3.8.3_UTF16_writing_bug.diff
 create mode 100644 abs/extra-testing/libftdi/PKGBUILD
 create mode 100644 abs/extra-testing/libmrss/PKGBUILD
 create mode 100644 abs/extra-testing/libnxml/PKGBUILD
 create mode 100644 abs/extra-testing/serdisplib/PKGBUILD
 create mode 100644 abs/extra-testing/xosd/PKGBUILD

diff --git a/abs/extra-testing/autoconf/PKGBUILD b/abs/extra-testing/autoconf/PKGBUILD
new file mode 100644
index 0000000..75bd7ef
--- /dev/null
+++ b/abs/extra-testing/autoconf/PKGBUILD
@@ -0,0 +1,25 @@
+# $Id: PKGBUILD 12545 2008-09-15 12:33:36Z andyrtr $
+# Maintainer: Andreas Radke <adyrtr@archlinux.org>
+
+pkgname=autoconf
+pkgver=2.63
+pkgrel=1
+pkgdesc="A GNU tool for automatically configuring source code"
+arch=(i686 x86_64)
+license=('GPL2' 'GPL3')
+url="http://www.gnu.org/software/autoconf"
+groups=('base-devel')
+depends=('awk' 'm4' 'diffutils' 'bash')
+install=autoconf.install
+source=(ftp://ftp.gnu.org/pub/gnu/${pkgname}/${pkgname}-${pkgver}.tar.gz)
+md5sums=('43d76649fb86cd21d64f68c48d5abdcf')
+
+build() {
+  cd ${srcdir}/${pkgname}-${pkgver}
+  ./configure --prefix=/usr
+  make || return 1
+  make DESTDIR=${pkgdir} install || return 1
+  rm -f ${pkgdir}/usr/share/info/dir
+  # conflict with bintuils
+  rm -f ${pkgdir}/usr/share/info/standards.info
+}
diff --git a/abs/extra-testing/autoconf/autoconf.install b/abs/extra-testing/autoconf/autoconf.install
new file mode 100644
index 0000000..6440ec6
--- /dev/null
+++ b/abs/extra-testing/autoconf/autoconf.install
@@ -0,0 +1,20 @@
+infodir=/usr/share/info
+filelist=(autoconf.info)
+
+post_install() {
+  for file in ${filelist[@]}; do
+    install-info $infodir/$file $infodir/dir 2> /dev/null
+  done
+}
+
+post_upgrade() {
+  post_install $1
+}
+
+pre_remove() {
+  for file in ${filelist[@]}; do
+    install-info --delete $infodir/$file $infodir/dir 2> /dev/null
+  done
+}
+
+# vim:set ts=2 sw=2 et:
diff --git a/abs/extra-testing/bmp/0.9.7-visualization.patch b/abs/extra-testing/bmp/0.9.7-visualization.patch
new file mode 100644
index 0000000..ac03323
--- /dev/null
+++ b/abs/extra-testing/bmp/0.9.7-visualization.patch
@@ -0,0 +1,12 @@
+--- beep/vis.c	2004-12-04 10:04:29.000000000 +0100
++++ beep/vis.c	2005-02-17 12:02:25.391044008 +0100
+@@ -223,7 +223,8 @@ vis_draw(Widget * w)
+     /* FIXME: The check "shouldn't" be neccessary? */
+     /*	if (GTK_IS_WINDOW(vis->vs_window)) { */
+     GDK_THREADS_ENTER();
+-    gdk_draw_indexed_image(vis->vs_window, vis->vs_widget.gc,
++    if (GDK_IS_DRAWABLE(vis->vs_window))
++        gdk_draw_indexed_image(vis->vs_window, vis->vs_widget.gc,
+                            vis->vs_widget.x, vis->vs_widget.y,
+                            vis->vs_widget.width, vis->vs_widget.height,
+                            GDK_RGB_DITHER_NORMAL, (guchar *) rgb_data,
diff --git a/abs/extra-testing/bmp/0.9.7.1-visualization.patch b/abs/extra-testing/bmp/0.9.7.1-visualization.patch
new file mode 100644
index 0000000..ac03323
--- /dev/null
+++ b/abs/extra-testing/bmp/0.9.7.1-visualization.patch
@@ -0,0 +1,12 @@
+--- beep/vis.c	2004-12-04 10:04:29.000000000 +0100
++++ beep/vis.c	2005-02-17 12:02:25.391044008 +0100
+@@ -223,7 +223,8 @@ vis_draw(Widget * w)
+     /* FIXME: The check "shouldn't" be neccessary? */
+     /*	if (GTK_IS_WINDOW(vis->vs_window)) { */
+     GDK_THREADS_ENTER();
+-    gdk_draw_indexed_image(vis->vs_window, vis->vs_widget.gc,
++    if (GDK_IS_DRAWABLE(vis->vs_window))
++        gdk_draw_indexed_image(vis->vs_window, vis->vs_widget.gc,
+                            vis->vs_widget.x, vis->vs_widget.y,
+                            vis->vs_widget.width, vis->vs_widget.height,
+                            GDK_RGB_DITHER_NORMAL, (guchar *) rgb_data,
diff --git a/abs/extra-testing/bmp/PKGBUILD b/abs/extra-testing/bmp/PKGBUILD
new file mode 100644
index 0000000..ffcc1bf
--- /dev/null
+++ b/abs/extra-testing/bmp/PKGBUILD
@@ -0,0 +1,25 @@
+# $Id: PKGBUILD 9914 2008-08-21 00:36:16Z eric $
+# Maintainer: Kevin Piche <kevin@archlinux.org>
+# Contributor: Ben <contrasutra@myrealbox.com>
+
+pkgname=bmp
+pkgver=0.9.7.1
+pkgrel=4
+pkgdesc="gtk2 port of xmms"
+arch=(i686 x86_64)
+url="http://bmp.beep-media-player.org/"
+depends=('esd' 'id3lib' 'libglade' 'libsm' 'libvorbis' 'unzip')
+source=(http://voxel.dl.sourceforge.net/sourceforge/beepmp/bmp-$pkgver.tar.gz $pkgver-visualization.patch bmp-${pkgver}-crossfade-0.3.9.patch)
+md5sums=('c25d5a8d49cc5851d13d525a20023c4c' 'fa1bdf5a8d03e8539a6bed5caa471176'\
+         '42ad4109ddb66024d4c6d1f3e572ab86')
+
+build() {
+  cd $startdir/src/$pkgname-$pkgver
+  patch -p0 -i ../${pkgver}-visualization.patch
+  patch -p1 -i ../${pkgname}-${pkgver}-crossfade-0.3.9.patch
+  ./configure --prefix=/usr
+  /usr/bin/make || return 1
+  /usr/bin/make DESTDIR=$startdir/pkg install
+  find $startdir/pkg -name '*.la' -exec rm {} \;
+}
+# vim: ts=2 sw=2 et ft=sh
diff --git a/abs/extra-testing/bmp/bmp-0.9.7.1-crossfade-0.3.9.patch b/abs/extra-testing/bmp/bmp-0.9.7.1-crossfade-0.3.9.patch
new file mode 100644
index 0000000..4c1e46d
--- /dev/null
+++ b/abs/extra-testing/bmp/bmp-0.9.7.1-crossfade-0.3.9.patch
@@ -0,0 +1,108 @@
+Patch taken from xmms-crossfade 3.10 tarball.  Required for crossfade to
+work.  http://www.eisenlohr.org/xmms-crossfade/
+
+diff -ur bmp-0.9.7.1/beep/mainwin.c bmp-0.9.7.1.patched/beep/mainwin.c
+--- bmp-0.9.7.1/beep/mainwin.c	2005-05-09 10:45:39.000000000 +0200
++++ bmp-0.9.7.1.patched/beep/mainwin.c	2005-11-25 00:03:59.000000000 +0100
+@@ -655,9 +655,11 @@
+     mainwin_set_shade(!cfg.player_shaded);
+ }
+ 
++gboolean is_quitting = FALSE;
+ void
+ mainwin_quit_cb(void)
+ {
++    is_quitting = TRUE;
+     gtk_widget_hide(equalizerwin);
+     gtk_widget_hide(playlistwin);
+     gtk_widget_hide(mainwin);
+@@ -1318,7 +1320,7 @@
+ change_song(guint pos)
+ {
+     if (bmp_playback_get_playing())
+-        bmp_playback_stop();
++        bmp_playback_stop_for_restart();
+ 
+     playlist_set_position(pos);
+     bmp_playback_initiate();
+diff -ur bmp-0.9.7.1/beep/playback.c bmp-0.9.7.1.patched/beep/playback.c
+--- bmp-0.9.7.1/beep/playback.c	2005-01-26 06:56:15.000000000 +0100
++++ bmp-0.9.7.1.patched/beep/playback.c	2005-11-25 00:03:59.000000000 +0100
+@@ -89,7 +89,7 @@
+         return;
+ 
+     if (bmp_playback_get_playing())
+-        bmp_playback_stop();
++        bmp_playback_stop_for_restart();
+ 
+     vis_clear_data(mainwin_vis);
+     vis_clear_data(playlistwin_vis);
+@@ -135,6 +135,15 @@
+     get_current_input_plugin()->pause(ip_data.paused);
+ }
+ 
++gboolean input_stopped_for_restart = FALSE;
++void
++bmp_playback_stop_for_restart(void)
++{
++	input_stopped_for_restart = TRUE;
++	bmp_playback_stop();
++	input_stopped_for_restart = FALSE;
++}
++
+ void
+ bmp_playback_stop(void)
+ {
+diff -ur bmp-0.9.7.1/beep/playback.h bmp-0.9.7.1.patched/beep/playback.h
+--- bmp-0.9.7.1/beep/playback.h	2004-12-04 10:04:26.000000000 +0100
++++ bmp-0.9.7.1.patched/beep/playback.h	2005-11-25 00:03:59.000000000 +0100
+@@ -26,6 +26,7 @@
+ void bmp_playback_initiate(void);
+ void bmp_playback_pause(void);
+ void bmp_playback_stop(void);
++void bmp_playback_stop_for_restart(void);
+ gboolean bmp_playback_play_file(const gchar * filename);
+ gboolean bmp_playback_get_playing(void);
+ gboolean bmp_playback_get_paused(void);
+diff -ur bmp-0.9.7.1/beep/playlist.c bmp-0.9.7.1.patched/beep/playlist.c
+--- bmp-0.9.7.1/beep/playlist.c	2005-08-11 09:25:51.000000000 +0200
++++ bmp-0.9.7.1.patched/beep/playlist.c	2005-11-25 00:03:59.000000000 +0100
+@@ -817,7 +817,7 @@
+     if (bmp_playback_get_playing()) {
+         /* We need to stop before changing playlist_position */
+         PLAYLIST_UNLOCK();
+-        bmp_playback_stop();
++        bmp_playback_stop_for_restart();
+         PLAYLIST_LOCK();
+         restart_playing = TRUE;
+     }
+@@ -868,7 +868,7 @@
+     if (bmp_playback_get_playing()) {
+         /* We need to stop before changing playlist_position */
+         PLAYLIST_UNLOCK();
+-        bmp_playback_stop();
++        bmp_playback_stop_for_restart();
+         PLAYLIST_LOCK();
+         restart_playing = TRUE;
+     }
+@@ -1018,7 +1018,7 @@
+     if (bmp_playback_get_playing()) {
+         /* We need to stop before changing playlist_position */
+         PLAYLIST_UNLOCK();
+-        bmp_playback_stop();
++        bmp_playback_stop_for_restart();
+         PLAYLIST_LOCK();
+         restart_playing = TRUE;
+     }
+@@ -1047,7 +1047,10 @@
+ {
+     GList *plist_pos_list;
+ 
+-    bmp_playback_stop();
++    if (cfg.repeat)
++        bmp_playback_stop_for_restart();
++    else
++        bmp_playback_stop();
+ 
+     PLAYLIST_LOCK();
+     plist_pos_list = find_playlist_position_list();
diff --git a/abs/extra-testing/gd/PKGBUILD b/abs/extra-testing/gd/PKGBUILD
new file mode 100644
index 0000000..11e2929
--- /dev/null
+++ b/abs/extra-testing/gd/PKGBUILD
@@ -0,0 +1,23 @@
+# $Id: PKGBUILD 356 2008-04-18 22:56:27Z aaron $
+# Maintainer: Eric Belanger <eric@archlinux.org>
+
+pkgname=gd
+pkgver=2.0.35
+pkgrel=1
+pkgdesc="Library for the dynamic creation of images by programmers"
+arch=('i686' 'x86_64')
+url="http://www.libgd.org/"
+license=('custom')
+depends=('libpng>=1.2.16' 'fontconfig>=2.4.2' 'libjpeg')
+options=('!libtool')
+source=(http://www.libgd.org/releases/${pkgname}-${pkgver}.tar.bz2)
+md5sums=('6c6c3dbb7bf079e0bb5fbbfd3bb8a71c')
+sha1sums=('ccf34a610abff2dbf133a20c4d2a4aa94939018a')
+
+build() {
+  cd ${startdir}/src/${pkgname}-${pkgver}
+  ./configure --prefix=/usr --without-xpm
+  make || return 1
+  make DESTDIR=${startdir}/pkg install
+  install -D -m644 COPYING $startdir/pkg/usr/share/licenses/$pkgname/COPYING
+}
diff --git a/abs/extra-testing/gdk-pixbuf/PKGBUILD b/abs/extra-testing/gdk-pixbuf/PKGBUILD
new file mode 100644
index 0000000..64b8b9a
--- /dev/null
+++ b/abs/extra-testing/gdk-pixbuf/PKGBUILD
@@ -0,0 +1,33 @@
+# $Id: PKGBUILD 20860 2008-12-07 04:28:44Z eric $
+# Maintainer: dorphell <dorphell@archlinux.org>
+# Committer: Judd Vinet <jvinet@zeroflux.org>
+
+pkgname=gdk-pixbuf
+pkgver=0.22.0
+pkgrel=4
+pkgdesc="Image loading and manipulation library"
+depends=(gtk libtiff libpng)
+options=(!libtool)
+arch=(i686 x86_64)
+source=(ftp://ftp.gnome.org/pub/gnome/sources/${pkgname}/0.22/${pkgname}-${pkgver}.tar.bz2
+	gdk-pixbuf-0.22.0-bmp_reject_corrupt.patch
+	gdk-pixbuf-0.22.0-bmp_secure.patch
+	gdk-pixbuf-0.22.0-loaders.patch
+	gdk-pixbuf-0.22.0-m4.patch)
+md5sums=(05fcb68ceaa338614ab650c775efc2f2 d1fb93f1ae994875158a7e0c108c36f8
+         5f59d5772b1482d885a180dbc581cf84 3cf31ae0509747f72ac27a9fd96109c2
+         3edfa9fe9382fd8206d6238ec121a5af)
+
+build() {
+  cd ${startdir}/src/${pkgname}-${pkgver}
+  export SED=/bin/sed
+  patch -Np1 -i ${startdir}/src/gdk-pixbuf-0.22.0-bmp_reject_corrupt.patch || return 1
+  patch -Np0 -i ${startdir}/src/gdk-pixbuf-0.22.0-bmp_secure.patch || return 1
+  patch -Np1 -i ${startdir}/src/gdk-pixbuf-0.22.0-loaders.patch || return 1
+  patch -Np1 -i ${startdir}/src/gdk-pixbuf-0.22.0-m4.patch || return 1
+  libtoolize --force --copy --automake
+  ./configure --prefix=/usr --disable-gtk-doc
+  make || return 1
+  make DESTDIR=${startdir}/pkg install
+  rm -rf ${startdir}/pkg/usr/share/gnome
+}
diff --git a/abs/extra-testing/gdk-pixbuf/gdk-pixbuf-0.22.0-bmp_reject_corrupt.patch b/abs/extra-testing/gdk-pixbuf/gdk-pixbuf-0.22.0-bmp_reject_corrupt.patch
new file mode 100644
index 0000000..ffb4378
--- /dev/null
+++ b/abs/extra-testing/gdk-pixbuf/gdk-pixbuf-0.22.0-bmp_reject_corrupt.patch
@@ -0,0 +1,48 @@
+--- gdk-pixbuf-0.22.0/gdk-pixbuf/io-bmp.c	2002-09-27 23:12:40.000000000 +0200
++++ gdk-pixbuf-0.22.0.patched/gdk-pixbuf/io-bmp.c	2005-03-30 01:33:06.000000000 +0200
+@@ -31,8 +31,6 @@
+ #include "gdk-pixbuf-private.h"
+ #include "gdk-pixbuf-io.h"
+ 
+-
+-
+ #if 0
+ /* If these structures were unpacked, they would define the two headers of the
+  * BMP file.  After them comes the palette, and then the image data.
+@@ -206,7 +204,7 @@
+ 
+ 	if (State == NULL)
+ 		return NULL;
+-
++ 	
+ 	while (feof(f) == 0) {
+ 		length = fread(membuf, 1, sizeof (membuf), f);
+ 		if (length > 0)
+@@ -245,11 +243,26 @@
+ static gboolean
+ grow_buffer (struct bmp_progressive_state *State)
+ {
+-  guchar *tmp = realloc (State->buff, State->BufferSize);
++  guchar *tmp;
++
++  if (State->BufferSize == 0) {
++#if 0
++    g_set_error (error,
++		 GDK_PIXBUF_ERROR,
++		 GDK_PIXBUF_ERROR_CORRUPT_IMAGE,
++		 _("BMP image has bogus header data"));
++#endif
++    State->read_state = READ_STATE_ERROR;
++    return FALSE;
++  }
++
++  tmp = realloc (State->buff, State->BufferSize);
++
+   if (!tmp) {
+     State->read_state = READ_STATE_ERROR;
+     return FALSE;
+   }
++
+   State->buff = tmp;
+   return TRUE;
+ }
diff --git a/abs/extra-testing/gdk-pixbuf/gdk-pixbuf-0.22.0-bmp_secure.patch b/abs/extra-testing/gdk-pixbuf/gdk-pixbuf-0.22.0-bmp_secure.patch
new file mode 100644
index 0000000..29471f1
--- /dev/null
+++ b/abs/extra-testing/gdk-pixbuf/gdk-pixbuf-0.22.0-bmp_secure.patch
@@ -0,0 +1,19 @@
+Index: io-bmp.c
+===================================================================
+RCS file: /cvs/gnome/gtk+/gdk-pixbuf/io-bmp.c,v
+retrieving revision 1.41
+diff -u -p -r1.41 io-bmp.c
+--- gdk-pixbuf/io-bmp.c	13 Aug 2004 02:26:57 -0000	1.41
++++ gdk-pixbuf/io-bmp.c	20 Aug 2004 00:18:14 -0000
+@@ -876,8 +876,10 @@ DoCompressed(struct bmp_progressive_stat
+ 	guchar c;
+ 	gint idx;
+ 
+-	if (context->compr.y >= context->Header.height)
++	if (context->compr.y >= context->Header.height) {
++		context->BufferDone = 0;
+ 		return TRUE;
++	}
+ 
+ 	y = context->compr.y;
+ 
diff --git a/abs/extra-testing/gdk-pixbuf/gdk-pixbuf-0.22.0-loaders.patch b/abs/extra-testing/gdk-pixbuf/gdk-pixbuf-0.22.0-loaders.patch
new file mode 100644
index 0000000..0686538
--- /dev/null
+++ b/abs/extra-testing/gdk-pixbuf/gdk-pixbuf-0.22.0-loaders.patch
@@ -0,0 +1,134 @@
+diff -NurdB gdk-pixbuf-0.22.0/gdk-pixbuf/io-ico.c gdk-pixbuf-0.22.0-patched/gdk-pixbuf/io-ico.c
+--- gdk-pixbuf-0.22.0/gdk-pixbuf/io-ico.c	2002-09-27 17:19:15.000000000 -0500
++++ gdk-pixbuf-0.22.0-patched/gdk-pixbuf/io-ico.c	2005-10-27 11:28:23.000000000 -0500
+@@ -330,6 +330,9 @@
+ 
+ 	State->HeaderSize+=I;
+ 
++ 	if (State->HeaderSize < 0)
++ 		return FALSE;
++ 
+  	if (State->HeaderSize>State->BytesInHeaderBuf) {
+ 		guchar *tmp=realloc(State->HeaderBuf,State->HeaderSize);
+ 		if (!tmp)
+diff -NurdB gdk-pixbuf-0.22.0/gdk-pixbuf/io-xpm.c gdk-pixbuf-0.22.0-patched/gdk-pixbuf/io-xpm.c
+--- gdk-pixbuf-0.22.0/gdk-pixbuf/io-xpm.c	2001-03-01 15:16:28.000000000 -0500
++++ gdk-pixbuf-0.22.0-patched/gdk-pixbuf/io-xpm.c	2005-10-27 11:29:14.000000000 -0500
+@@ -243,8 +243,8 @@
+ 			break;
+ 		else {
+ 			if (numnames > 0) {
+-				space -= 1;
+-				strcat (color, " ");
++				strncat (color, " ", space);
++				space -= MIN (space, 1);
+ 			}
+ 
+ 			strncat (color, temp, space);
+@@ -281,7 +281,8 @@
+ 		/* Fall through to the xpm_read_string. */
+ 
+ 	case op_body:
+-		xpm_read_string (h->infile, &h->buffer, &h->buffer_size);
++		if(!xpm_read_string (h->infile, &h->buffer, &h->buffer_size))
++			return NULL;
+ 		return h->buffer;
+ 
+ 	default:
+@@ -317,13 +318,6 @@
+ 	return NULL;
+ }
+ 
+-/* Destroy notification function for the pixbuf */
+-static void
+-free_buffer (guchar *pixels, gpointer data)
+-{
+-	free (pixels);
+-}
+-
+ static gboolean
+ xpm_color_parse (const char *spec, XColor *color)
+ {
+@@ -342,7 +336,8 @@
+ 	gchar pixel_str[32];
+ 	GHashTable *color_hash;
+ 	_XPMColor *colors, *color, *fallbackcolor;
+-	guchar *pixels, *pixtmp;
++	guchar *pixtmp;
++	GdkPixbuf* pixbuf;
+ 
+ 	fallbackcolor = NULL;
+ 
+@@ -352,16 +347,33 @@
+ 		return NULL;
+ 	}
+ 	sscanf (buffer, "%d %d %d %d", &w, &h, &n_col, &cpp);
+-	if (cpp >= 32) {
+-		g_warning ("XPM has more than 31 chars per pixel.");
++	if (cpp <= 0 || cpp >= 32) {
++		g_warning ("XPM has invalid number of chars per pixel.");
+ 		return NULL;
+ 	}
++	if (n_col <= 0 ||
++	    n_col >= G_MAXINT / (cpp + 1) ||
++	    n_col >= G_MAXINT / sizeof (_XPMColor)) {
++		g_warning ("XPM file has invalid number of colors");
++  		return NULL;
++  	}
+ 
+ 	/* The hash is used for fast lookups of color from chars */
+ 	color_hash = g_hash_table_new (g_str_hash, g_str_equal);
+ 
+-	name_buf = g_new (gchar, n_col * (cpp + 1));
+-	colors = g_new (_XPMColor, n_col);
++ 	name_buf = g_new (gchar, n_col * (cpp + 1));
++ 	if (!name_buf) {
++		g_warning ("Cannot allocate memory for loading XPM image");
++ 		g_hash_table_destroy (color_hash);
++ 		return NULL;
++ 	}
++ 	colors = g_new (_XPMColor, n_col);
++ 	if (!colors) {
++		g_warning ("Cannot allocate memory for loading XPM image");
++ 		g_hash_table_destroy (color_hash);
++ 		g_free (name_buf);
++ 		return NULL;
++ 	}
+ 
+ 	for (cnt = 0; cnt < n_col; cnt++) {
+ 		gchar *color_name;
+@@ -397,12 +409,8 @@
+ 			fallbackcolor = color;
+ 	}
+ 
+-	if (is_trans)
+-		pixels = malloc (w * h * 4);
+-	else
+-		pixels = malloc (w * h * 3);
+-
+-	if (!pixels) {
++	pixbuf = gdk_pixbuf_new(GDK_COLORSPACE_RGB, is_trans, 8, w, h);
++	if (!pixbuf) {
+ 		g_hash_table_destroy (color_hash);
+ 		g_free (colors);
+ 		g_free (name_buf);
+@@ -410,7 +418,7 @@
+ 	}
+ 
+ 	wbytes = w * cpp;
+-	pixtmp = pixels;
++	pixtmp = pixbuf->pixels;
+ 
+ 	for (ycnt = 0; ycnt < h; ycnt++) {
+ 		buffer = (*get_buf) (op_body, handle);
+@@ -443,9 +451,7 @@
+ 	g_free (colors);
+ 	g_free (name_buf);
+ 
+-	return gdk_pixbuf_new_from_data (pixels, GDK_COLORSPACE_RGB, is_trans, 8,
+-					 w, h, is_trans ? (w * 4) : (w * 3),
+-					 free_buffer, NULL);
++	return pixbuf;
+ }
+ 
+ /* Shared library entry point for file loading */
diff --git a/abs/extra-testing/gdk-pixbuf/gdk-pixbuf-0.22.0-m4.patch b/abs/extra-testing/gdk-pixbuf/gdk-pixbuf-0.22.0-m4.patch
new file mode 100644
index 0000000..032976d
--- /dev/null
+++ b/abs/extra-testing/gdk-pixbuf/gdk-pixbuf-0.22.0-m4.patch
@@ -0,0 +1,9 @@
+Fix aclocal warning:
+/usr/share/aclocal/gdk-pixbuf.m4:12: warning: underquoted definition of AM_PATH_GDK_PIXBUF
+--- gdk-pixbuf-0.22.0/gdk-pixbuf.m4
++++ gdk-pixbuf-0.22.0/gdk-pixbuf.m4
+@@ -11,3 +11,3 @@
+ dnl
+-AC_DEFUN(AM_PATH_GDK_PIXBUF,
++AC_DEFUN([AM_PATH_GDK_PIXBUF],
+ [dnl 
diff --git a/abs/extra-testing/id3lib/PKGBUILD b/abs/extra-testing/id3lib/PKGBUILD
new file mode 100644
index 0000000..ba0328a
--- /dev/null
+++ b/abs/extra-testing/id3lib/PKGBUILD
@@ -0,0 +1,29 @@
+# $Id: PKGBUILD 2134 2008-05-26 00:30:40Z eric $
+# Maintainer: 
+# Contributor: Jochem Kossen <j.kossen@home.nl>
+pkgname=id3lib
+pkgver=3.8.3
+pkgrel=10
+pkgdesc="An open-source, cross-platform software development library for reading, writing, and manipulating ID3v1 and ID3v2 tags"
+arch=(i686 x86_64)
+license=('LGPL')
+url="http://id3lib.sourceforge.net/"
+depends=('zlib' 'gcc-libs')
+options=('!libtool')
+source=(http://downloads.sourceforge.net/sourceforge/${pkgname}/${pkgname}-${pkgver}.tar.gz
+	patch_id3lib_3.8.3_UTF16_writing_bug.diff
+	id3lib-3.8.3-CVE-2007-4460.patch
+	id3lib-3.8.3-gcc-4.3.patch)
+md5sums=('19f27ddd2dda4b2d26a559a4f0f402a7' '196c65adee1ba511ddacef2de0dfd102'\
+         '78e90e15ddd1122b66da352b6c3b00ff' 'fdbffd2d9d289ed0d730950c78d4ebc4')
+
+build() {
+  cd ${startdir}/src/${pkgname}-${pkgver}
+  patch -Np1 -i ${startdir}/src/patch_id3lib_3.8.3_UTF16_writing_bug.diff || return 1
+  patch -Np0 -i ${startdir}/src/id3lib-3.8.3-CVE-2007-4460.patch || return 1
+  patch -Np1 -i ${startdir}/src/id3lib-3.8.3-gcc-4.3.patch || return 1
+  ./configure --prefix=/usr
+  sed -i -e 's/^LIBS =/LIBS = -lz -lstdc++/' src/Makefile || return 1
+  make || return 1
+  make DESTDIR=${startdir}/pkg install
+}
diff --git a/abs/extra-testing/id3lib/id3lib-3.8.3-CVE-2007-4460.patch b/abs/extra-testing/id3lib/id3lib-3.8.3-CVE-2007-4460.patch
new file mode 100644
index 0000000..daa0866
--- /dev/null
+++ b/abs/extra-testing/id3lib/id3lib-3.8.3-CVE-2007-4460.patch
@@ -0,0 +1,49 @@
+--- src/tag_file.cpp
++++ src/tag_file.cpp
+@@ -242,8 +242,8 @@
+     strcpy(sTempFile, filename.c_str());
+     strcat(sTempFile, sTmpSuffix.c_str());
+ 
+-#if ((defined(__GNUC__) && __GNUC__ >= 3  ) || !defined(HAVE_MKSTEMP))
+-    // This section is for Windows folk && gcc 3.x folk
++#if !defined(HAVE_MKSTEMP)
++    // This section is for Windows folk
+     fstream tmpOut;
+     createFile(sTempFile, tmpOut);
+ 
+@@ -257,7 +257,7 @@
+       tmpOut.write((char *)tmpBuffer, nBytes);
+     }
+ 
+-#else //((defined(__GNUC__) && __GNUC__ >= 3  ) || !defined(HAVE_MKSTEMP))
++#else //!defined(HAVE_MKSTEMP)
+ 
+     // else we gotta make a temp file, copy the tag into it, copy the
+     // rest of the old file after the tag, delete the old file, rename
+@@ -270,7 +270,7 @@
+       //ID3_THROW_DESC(ID3E_NoFile, "couldn't open temp file");
+     }
+ 
+-    ofstream tmpOut(fd);
++    ofstream tmpOut(sTempFile);
+     if (!tmpOut)
+     {
+       tmpOut.close();
+@@ -285,14 +285,14 @@
+     uchar tmpBuffer[BUFSIZ];
+     while (file)
+     {
+-      file.read(tmpBuffer, BUFSIZ);
++      file.read((char *)tmpBuffer, BUFSIZ);
+       size_t nBytes = file.gcount();
+-      tmpOut.write(tmpBuffer, nBytes);
++      tmpOut.write((char *)tmpBuffer, nBytes);
+     }
+ 
+     close(fd); //closes the file
+ 
+-#endif ////((defined(__GNUC__) && __GNUC__ >= 3  ) || !defined(HAVE_MKSTEMP))
++#endif ////!defined(HAVE_MKSTEMP)
+ 
+     tmpOut.close();
+     file.close();
diff --git a/abs/extra-testing/id3lib/id3lib-3.8.3-gcc-4.3.patch b/abs/extra-testing/id3lib/id3lib-3.8.3-gcc-4.3.patch
new file mode 100644
index 0000000..f5ec498
--- /dev/null
+++ b/abs/extra-testing/id3lib/id3lib-3.8.3-gcc-4.3.patch
@@ -0,0 +1,83 @@
+diff -Naur id3lib-3.8.3-orig/configure id3lib-3.8.3/configure
+--- id3lib-3.8.3-orig/configure      2008-05-24 23:39:36.000000000 -0400
++++ id3lib-3.8.3/configure   2008-05-24 23:39:57.000000000 -0400
+@@ -10296,8 +10296,7 @@
+ 
+ for ac_header in \
+   string                        \
+-  iomanip.h                     \
+ 
+ do
+ as_ac_Header=`echo "ac_cv_header_$ac_header" | $as_tr_sh`
+ 
+diff -Naur id3lib-3.8.3-orig/include/id3/id3lib_strings.h id3lib-3.8.3/include/id3/id3lib_strings.h
+--- id3lib-3.8.3-orig/include/id3/id3lib_strings.h	2008-03-05 18:19:46.000000000 -0600
++++ id3lib-3.8.3/include/id3/id3lib_strings.h	2008-03-05 18:19:38.000000000 -0600
+@@ -30,6 +30,7 @@
+ #define _ID3LIB_STRINGS_H_
+ 
+ #include <string>
++#include <cstring>
+ 
+ #if (defined(__GNUC__) && (__GNUC__ >= 3) || (defined(_MSC_VER) && _MSC_VER > 1000))
+ namespace std
+diff -Naur id3lib-3.8.3-orig/include/id3/writers.h id3lib-3.8.3/include/id3/writers.h
+--- id3lib-3.8.3-orig/include/id3/writers.h	2003-03-01 18:23:00.000000000 -0600
++++ id3lib-3.8.3/include/id3/writers.h	2008-03-05 18:23:05.000000000 -0600
+@@ -30,7 +30,7 @@
+ 
+ #include "id3/writer.h"
+ #include "id3/id3lib_streams.h"
+-//#include <string.h>
++#include <string.h>
+ 
+ class ID3_CPP_EXPORT ID3_OStreamWriter : public ID3_Writer
+ {
+diff -Naur id3lib-3.8.3-orig/examples/demo_convert.cpp id3lib-3.8.3/examples/demo_convert.cpp
+--- id3lib-3.8.3-orig/examples/demo_convert.cpp	2003-03-01 18:23:00.000000000 -0600
++++ id3lib-3.8.3/examples/demo_convert.cpp	2008-03-05 18:26:50.000000000 -0600
+@@ -84,7 +84,7 @@
+   }
+ }
+ 
+-int main( unsigned int argc, char * const argv[])
++int main( int argc, char * const argv[])
+ {
+   flags_t ulFlag = ID3TT_ALL;
+   gengetopt_args_info args;
+diff -Naur id3lib-3.8.3-orig/examples/demo_info.cpp id3lib-3.8.3/examples/demo_info.cpp
+--- id3lib-3.8.3-orig/examples/demo_info.cpp	2003-03-01 18:23:00.000000000 -0600
++++ id3lib-3.8.3/examples/demo_info.cpp	2008-03-05 18:27:40.000000000 -0600
+@@ -309,7 +309,7 @@
+ 
+ #define DEBUG
+ 
+-int main( unsigned int argc, char * const argv[])
++int main( int argc, char * const argv[])
+ {
+   ID3D_INIT_DOUT();
+ 
+diff -Naur id3lib-3.8.3-orig/examples/demo_tag.cpp id3lib-3.8.3/examples/demo_tag.cpp
+--- id3lib-3.8.3-orig/examples/demo_tag.cpp	2003-03-01 18:23:00.000000000 -0600
++++ id3lib-3.8.3/examples/demo_tag.cpp	2008-03-05 18:31:20.000000000 -0600
+@@ -46,7 +46,7 @@
+     os << "v2";
+ }
+ 
+-int main( unsigned int argc, char * const argv[])
++int main( int argc, char * const argv[])
+ {
+   int ulFlag = ID3TT_ID3;
+   ID3D_INIT_DOUT();
+diff -Naur id3lib-3.8.3-orig/examples/demo_copy.cpp id3lib-3.8.3/examples/demo_copy.cpp
+--- id3lib-3.8.3-orig/examples/demo_copy.cpp	2003-03-01 18:23:00.000000000 -0600
++++ id3lib-3.8.3/examples/demo_copy.cpp	2008-03-05 18:32:44.000000000 -0600
+@@ -81,7 +81,7 @@
+   }
+ }
+ 
+-int main( unsigned int argc, char * const argv[])
++int main( int argc, char * const argv[])
+ {
+   int ulFlag = ID3TT_ID3;
+   ID3D_INIT_DOUT();
diff --git a/abs/extra-testing/id3lib/patch_id3lib_3.8.3_UTF16_writing_bug.diff b/abs/extra-testing/id3lib/patch_id3lib_3.8.3_UTF16_writing_bug.diff
new file mode 100644
index 0000000..b05d2cf
--- /dev/null
+++ b/abs/extra-testing/id3lib/patch_id3lib_3.8.3_UTF16_writing_bug.diff
@@ -0,0 +1,39 @@
+diff -ruN id3lib-3.8.3.orig/ChangeLog id3lib-3.8.3/ChangeLog
+--- id3lib-3.8.3.orig/ChangeLog	2003-03-02 01:23:00.000000000 +0100
++++ id3lib-3.8.3/ChangeLog	2006-02-22 00:33:59.946214472 +0100
+@@ -1,3 +1,8 @@
++2006-02-17  Jerome Couderc
++
++    * Patch from Spoon to fix UTF-16 writing bug
++      http://sourceforge.net/tracker/index.php?func=detail&aid=1016290&group_id=979&atid=300979
++
+ 2003-03-02 Sunday 17:38   Thijmen Klok <thijmen@id3lib.org>
+ 
+ 	* THANKS (1.20): added more people 
+diff -ruN id3lib-3.8.3.orig/src/io_helpers.cpp id3lib-3.8.3/src/io_helpers.cpp
+--- id3lib-3.8.3.orig/src/io_helpers.cpp	2003-03-02 01:23:00.000000000 +0100
++++ id3lib-3.8.3/src/io_helpers.cpp	2006-02-22 00:35:02.926639992 +0100
+@@ -363,11 +363,22 @@
+     // Write the BOM: 0xFEFF
+     unicode_t BOM = 0xFEFF;
+     writer.writeChars((const unsigned char*) &BOM, 2);
++    // Patch from Spoon : 2004-08-25 14:17
++    //   http://sourceforge.net/tracker/index.php?func=detail&aid=1016290&group_id=979&atid=300979
++    // Wrong code
++    //for (size_t i = 0; i < size; i += 2)
++    //{
++    //  unicode_t ch = (data[i] << 8) | data[i+1];
++    //  writer.writeChars((const unsigned char*) &ch, 2);
++    //}
++    // Right code
++    unsigned char *pdata = (unsigned char *) data.c_str();
+     for (size_t i = 0; i < size; i += 2)
+     {
+-      unicode_t ch = (data[i] << 8) | data[i+1];
++      unicode_t ch = (pdata[i] << 8) | pdata[i+1];
+       writer.writeChars((const unsigned char*) &ch, 2);
+     }
++    // End patch
+   }
+   return writer.getCur() - beg;
+ }
diff --git a/abs/extra-testing/libftdi/PKGBUILD b/abs/extra-testing/libftdi/PKGBUILD
new file mode 100644
index 0000000..b435b9a
--- /dev/null
+++ b/abs/extra-testing/libftdi/PKGBUILD
@@ -0,0 +1,19 @@
+# Contributor: Bernhard Walle <bernhard.walle@gmx.de>
+pkgname=libftdi
+pkgver=0.13
+pkgrel=0
+pkgdesc="Library to program and control the FTDI USB controller"
+url="http://www.intra2net.com/de/produkte/opensource/ftdi/"
+license="GPL"
+depends=(libusb)
+arch=(i686 x86_64)
+source=(http://www.intra2net.com/de/produkte/opensource/ftdi/TGZ/$pkgname-$pkgver.tar.gz)
+md5sums=('7b4a660fd644980f3d45873d156d021a')
+
+build() {
+  cd $startdir/src/$pkgname-$pkgver
+  ./configure --prefix=/usr --sysconfdir=/etc
+  make
+  make DESTDIR=$startdir/pkg install
+}
+# :mode=shellscript:
diff --git a/abs/extra-testing/libmrss/PKGBUILD b/abs/extra-testing/libmrss/PKGBUILD
new file mode 100644
index 0000000..7d23508
--- /dev/null
+++ b/abs/extra-testing/libmrss/PKGBUILD
@@ -0,0 +1,20 @@
+# Contributor: Bernhard Walle <bernhard.walle@gmx.de>
+pkgname=libmrss
+pkgver=0.19.2
+pkgrel=1
+pkgdesc="C library for parsing, writing and creating RSS/ATOM files or streams"
+url="http://www2.autistici.org/bakunin/libmrss/"
+license="LGPL"
+depends=(curl libnxml)
+arch=('i686' 'x86_64')
+options=('!libtool')
+source=(http://www2.autistici.org/bakunin/libmrss/$pkgname-$pkgver.tar.gz)
+md5sums=('a6f66b72898d27270e3a68007f90d62b')
+
+build() {
+  cd $startdir/src/$pkgname-$pkgver
+  ./configure --prefix=/usr
+  make || return 1
+  make DESTDIR=$startdir/pkg install
+}
+# :mode=shellscript:
diff --git a/abs/extra-testing/libnxml/PKGBUILD b/abs/extra-testing/libnxml/PKGBUILD
new file mode 100644
index 0000000..0c4f9cb
--- /dev/null
+++ b/abs/extra-testing/libnxml/PKGBUILD
@@ -0,0 +1,22 @@
+# $Id: PKGBUILD,v 1.1 2008/09/27 07:05:31 allan Exp $
+# Maintainer: Allan McRae <allan@archlinux.org>
+# Contributor: Bernhard Walle <bernhard.walle@gmx.de>
+
+pkgname=libnxml
+pkgver=0.18.3
+pkgrel=1
+pkgdesc="C library for parsing, writing and creating XML 1.0 and 1.1 files or streams"
+url="http://www2.autistici.org/bakunin//libnxml/"
+license=('LGPL')
+depends=('curl')
+arch=('i686' 'x86_64')
+options=('!libtool')
+source=(http://www2.autistici.org/bakunin//libnxml/$pkgname-$pkgver.tar.gz)
+md5sums=('857f43970e7f0724d28f4ddc87085daf')
+
+build() {
+    cd $srcdir/$pkgname-$pkgver
+    ./configure --prefix=/usr
+    make || return 1
+    make DESTDIR=$pkgdir install
+}
diff --git a/abs/extra-testing/serdisplib/PKGBUILD b/abs/extra-testing/serdisplib/PKGBUILD
new file mode 100644
index 0000000..454769b
--- /dev/null
+++ b/abs/extra-testing/serdisplib/PKGBUILD
@@ -0,0 +1,22 @@
+# Contributor: Bernhard Walle <bernhard.walle@gmx.de>
+pkgname=serdisplib
+pkgver=1.97.8
+pkgrel=1
+pkgdesc="Library for Certain Serial and Parallel LC Displays"
+url="http://serdisplib.sourceforge.net/"
+license="GPL"
+depends=(libusb gd)
+backup=(etc/LCDd.conf)
+arch=(i686 x86_64)
+source=(http://switch.dl.sourceforge.net/sourceforge/$pkgname/$pkgname-$pkgver.tar.gz)
+md5sums=('2aa91c43d01d2dfc9fbc1116e3063ae1')
+
+build() {
+  cd $startdir/src/$pkgname-$pkgver
+  ./configure --prefix=/usr --sysconfdir=/etc --enable-libusb
+  make
+  make DESTDIR=$startdir/pkg includedir=$startdir/pkg/usr/include \
+        libdir=$startdir/pkg/usr/lib bindir=$startdir/pkg/usr/bin \
+        install
+}
+# :mode=shellscript:
diff --git a/abs/extra-testing/xosd/PKGBUILD b/abs/extra-testing/xosd/PKGBUILD
new file mode 100644
index 0000000..e4a87ba
--- /dev/null
+++ b/abs/extra-testing/xosd/PKGBUILD
@@ -0,0 +1,26 @@
+# $Id: PKGBUILD 356 2008-04-18 22:56:27Z aaron $
+# Maintainer: damir <damir@archlinux.org>
+# Contributor: Damir Perisa <damir.perisa@bluewin.ch>
+
+pkgname=xosd
+pkgver=2.2.14
+pkgrel=1
+pkgdesc="XOSD displays text on your screen. On-Screen-Display-libs for some tools."
+arch=("i686" "x86_64")
+license=('GPL2')
+url="http://www.ignavus.net/software.html"
+depends=('libxt' 'libxinerama' 'gdk-pixbuf')
+makedepends=('xmms' 'bmp')
+options=(!libtool)
+#source=("http://www.ignavus.net/xosd-$pkgver.tar.bz2")
+source=("http://ftp.de.debian.org/debian/pool/main/x/xosd/xosd_$pkgver.orig.tar.gz")
+
+build() {
+  cd $startdir/src/xosd-$pkgver
+  ./configure --prefix=/usr
+  make || return 1
+  make DESTDIR=$startdir/pkg/ install
+}
+
+
+md5sums=('4b349fe930e4eee2f504d6c02673e24d')
-- 
cgit v0.12